'use strict';

/**
 * @file Some useful functions.
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Common = function () {
  function Common() {
    _classCallCheck(this, Common);
  }

  _createClass(Common, null, [{
    key: 'escapeHtml',


    /**
     * Transform html tag to escaped form.
     * @param str           Input string
     * @returns {string}    Escape string.
     */
    value: function escapeHtml(str) {
      var entityMap = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#39;',
        '/': '&#x2F;',
        '`': '&#x60;',
        '=': '&#x3D;'
      };
      return String(str).replace(/[&<>"'`=\/]/g, function (s) {
        return entityMap[s];
      });
    }

    /**
     * Check if a value is array type.
     * @param object
     * @returns {*|(function())}
       */

  }, {
    key: 'isArray',
    value: function isArray(object) {
      return Array.isArray || Object.prototype.toString.call(object) === '[object Array]';
    }
  }]);

  return Common;
}();

exports.default = Common;