'use strict';

/**
 * @file Template engine context, by wrapping a view object.
 *
 * // To do: support traversal up the context hierarchy if the value is absent in this context's view.
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Context = function () {
  /**
   * @brief Constructor
   *
   * @param view  {Object} Data object.
   */

  function Context(view) {
    _classCallCheck(this, Context);

    this.view = view;
  }

  /**
   * Creates a new context using the given view
   * @param view
   * @returns {Context}
     */


  _createClass(Context, [{
    key: 'push',
    value: function push(view) {
      return new Context(view);
    }

    /**
     * Find the value of giving name in context
     * @param name  Given name, support dot notion (eg: person.name)
     */

  }, {
    key: 'lookup',
    value: function lookup(name) {
      var names = void 0,
          namesLen = void 0,
          value = void 0,
          context = this;
      if (name.indexOf('.') > 0) {
        value = context.view;
        names = name.split('.');
        namesLen = names.length;

        // Support dot notion
        var index = 0;
        while (value && index < namesLen) {
          value = value[names[index++]];
        }
      } else {
        value = context.view[name];
      }

      return value;
    }
  }]);

  return Context;
}();

exports.default = Context;