'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = render;
exports.parse = parse;

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

var _writer = require('./writer');

var _writer2 = _interopRequireDefault(_writer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file stouts.js, High-level function, template engine entrance file.
 *
 */

/**
 * Convert template and view object together into a string.
 */
function render(template, view) {
  var writer = new _writer2.default(template, view);
  return writer.render();
}

/**
 * Convert template and view object together into a string.
 */
function parse(template) {
  var parser = new _parser2.default(template);
  return parser.parse();
}