'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

var _common = require('./common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @file Convert template and view object together into a string.
 *
 */

var Writer = function () {
  /**
   * @brief Constructor
   *
   * @param template  {String} Template string
   * @param view  {Object} View Object
   */

  function Writer(template, view) {
    _classCallCheck(this, Writer);

    this.template = template;
    this.view = view;
  }

  _createClass(Writer, [{
    key: 'renderTokens',
    value: function renderTokens(tokens, context) {
      var token = void 0,
          renderedStr = '';
      for (var i = 0, len = tokens.length; i < len; i++) {
        token = tokens[i];

        if (token[0] === 'text') {
          renderedStr += token[1];
        } else if (token[0] === 'name') {
          renderedStr += _common2.default.escapeHtml(context.lookup(token[1]));
        } else if (token[0] === '&') {
          renderedStr += context.lookup(token[1]);
        } else if (token[0] === '#') {
          renderedStr += this.renderSections(token, context);
        }
      }
      return renderedStr;
    }
  }, {
    key: 'renderSections',
    value: function renderSections(token, context) {
      var renderedStr = '';
      var value = context.lookup(token[1]);
      if (_common2.default.isArray(value)) {
        for (var j = 0, valueLength = value.length; j < valueLength; j++) {
          renderedStr += this.renderTokens(token[4], context.push(value[j]));
        }
      }
      return renderedStr;
    }

    /**
     * Convert template and view object together into a string.
     */

  }, {
    key: 'render',
    value: function render() {
      var parser = new _parser2.default(this.template);
      var context = new _context2.default(this.view);
      var tokens = parser.parse();

      return this.renderTokens(tokens, context);
    }
  }]);

  return Writer;
}();

exports.default = Writer;